function address(a:integer):integer;
begin
  address:=a;
end;

function datecheck(d1, d2: daterec): boolean;  { returns true if d1>d2 }
begin
  if d1.year <> d2.year  then
    datecheck:=d1.year >d2.year
  else
    if d1.month<> d2.month then
       datecheck:=d1.month>d2.month
    else
      datecheck:=d1.day>d2.day
end;


procedure writedate(d:daterec);
var
  s:string[3];
begin
  with d do
    begin
      s:='**-';
      s[1]:=chr((day div 10)+ord('0'));
      s[2]:=chr((day mod 10)+ord('0'));
      if s[1]='0' then
        s[1]:=' ';
      unitwrite(1,s[1],3,0,12);
      s:=copy('000JanFebMarAprMayJunJulAugSepOctNovDecDDDEEEFFF',month*3+1,3);
      unitwrite(1,s[1],3,0,12);
      s:='-**';
      s[2]:=chr(((year mod 100) div 10)+ord('0'));
      s[3]:=chr((year mod 10)+ord('0'));
      unitwrite(1,s[1],2,0,12);
    end;
end;

function validdate(dd:daterec):boolean;
    var
      leapyear:boolean;
      d:daterec;
      month,date,year:integer;
    begin
      d:=dd;
      month := d.month;
      date  := d.day;
      if d.year<100 then
        year  := d.year+1900
      else
        year:=0;
      leapyear := ( ( ( year mod   4  = 0 ) and
                      ( year mod 100 <> 0 ) ) or
                    ( year mod 400 = 0 ) );

      if (year>60) and (month>0) and (month<13) and (date>0) and
          (((month in [4,6,8,11]) and (date<31)) or
           ((month in [1,3,5,7,8,10,12]) and (date<32)) or
           (((month=2)and not leapyear and ( date < 29 )) or
           ((month=2)and leapyear and (date<30))))
          then
        validdate:=true
      else
        validdate:=false;
    end;
  
   function dayofweek(date:daterec):weekday;
  const
    startyear=60;
    startday =5;
  var
    wd:weekday;
    d:daterec;
    leapyear:boolean;
    month,day,year,j,date1:integer;
  begin
    wd:=invalid;
    day:=startday;
    d:=date;
    month := d.month;
    date1  := d.day;
    year  := d.year;
    leapyear := year mod   4  = 0;

    if  (year>60)  and
        (month>0)  and
        (month<13) and
        (date1>0)  and
        (
         ((month in [4,6,8,11]) and (date1<31)) or
         ((month in [1,3,5,7,8,10,12]) and (date1<32)) or
         ((month=2)and not leapyear and (date1<29)) or
         ((month=2)and leapyear and (date1<30))
        ) then
      begin
        for j:=startyear to year-1 do
          if j mod 4=0 then
            day:=day+2
          else
            day:=day+1;
        case month of
          2:day:=day+31;
          3:day:=day+59;
          4:day:=day+90;
          5:day:=day+120;
          6:day:=day+151;
          7:day:=day+181;
          8:day:=day+212;
          9:day:=day+243;
          10:day:=day+273;
          11:day:=day+304;
          12:day:=day+334;
        end;
        if (month>2)and(((year mod 4=0) and (year mod 100<>0))
           or(year mod 400=0))
             then day:=day+1;
        day:=day+date1-1;
        day:=day mod 7;
        case day of
          0:wd:=sunday;
          1:wd:=monday;
          2:wd:=tuesday;
          3:wd:=wednesday;
          4:wd:=thursday;
          5:wd:=friday;
          6:wd:=saturday;
        end;
      end;
    dayofweek:=wd;
  end;

function check_type(unitnum:integer):dtype;
  var
    buffer:packed array[0..511] of 0..255;
  begin
    unitread(unitnum,buffer,512,0);
    IF (( BUFFER[254] = 234 ) AND ( BUFFER[255] =  74 )) OR
       (( BUFFER[254] =  76 ) AND ( BUFFER[255] =  21 )) OR
       (( BUFFER[254] =   0 ) AND ( BUFFER[255] =  74 )) OR
       (( BUFFER[254] = 232 ) AND ( BUFFER[255] = 142 )) THEN
      check_type:=pas
    ELSE
      IF (( BUFFER[254] = 229 ) AND ( BUFFER[255] = 229 )) OR
         (( BUFFER[254] = 255 ) AND ( BUFFER[255] = 255 )) THEN
        check_type:=cpm
      ELSE
        IF (( BUFFER[254] = 182 ) AND ( BUFFER[255] =   9 )) OR
           (( BUFFER[254] =  54 ) AND ( BUFFER[255] =   9 )) OR
           (( BUFFER[254] = 173 ) AND ( BUFFER[255] = 196 )) THEN
          check_type:=dos
        ELSE
          IF (( BUFFER[254] =  32 ) AND ( BUFFER[255] =  76 )) OR
             (( BUFFER[254] =  41 ) AND ( BUFFER[255] = 240 )) THEN
            checktype:=pro
          ELSE
            checktype:=unknown;
  end;


function compact_disk(gunit:integer):boolean;

label 1,2;

  VAR
    NBLOCKS,
    DESTBLK,
    RELBLK,
    CHUNKSIZE:  INTEGER;
    GDIR:       DIRECTORY;
    BUFFER:     ^BUFF;
    LINX:       DIRRANGE;
    trick:record case boolean of
      true:(i:^integer);
      false:(b:^buff);
    end;
    z:^integer;
    gbufblks:integer;
    gch:char;
    
  
  BEGIN
    gch:='.';
    { set memory usable }
    gbufblks:=(memavail div 256)-2;
    if gbufblks>63 then
      gbufblks:=63;
    new(z);
    if (gbufblks<4) or ( not (gunit in [4,5,9..20])) then
1:    begin
        compact_disk:=false;
        goto 2;
      end;
    trick.i:=z;
    buffer:=trick.b;
    { sometimes pascal 1.2 and 1.1 goes off line on disks. }
    unitread(gunit,gdir,sizeof(gdir),9);     { dummy read for online fixes }
    if ioresult<>0 then
      goto 1;
    fillchar(gdir,sizeof(gdir),chr(0));
    unitread(gunit,gdir,sizeof(gdir),2);
    if ioresult<>0 then
      goto 1;
    { follow all files }
    for linx:=1 to gdir[0].dnumfiles do
      with gdir[linx] do
        if (dfkind<>xdskfile) and (dfirstblk>gdir[linx-1].dlastblk) then
          { move file }
          begin
            nblocks:=dlastblk-dfirstblk;
            destblk:=gdir[linx-1].dlastblk;
            relblk:=0;
            repeat
              chunksize:=nblocks-relblk;
              if chunksize>gbufblks then
                chunksize:=gbufblks;
              if chunksize>0 then
                begin
                  unitwrite(1,gch,1);
                  unitread(gunit,buffer^,512*chunksize,dfirstblk+relblk);
                  unitwrite(1,gch,1);
                  unitwrite(gunit,buffer^,512*chunksize,destblk+relblk);
                  relblk:=relblk+chunksize;
                end;
            until chunksize=0;
            dfirstblk:=destblk;
            dlastblk:=destblk+nblocks;
          end;
    unitwrite(gunit,gdir,sizeof(gdir),2);
    if ioresult<>0 then
      goto 1;
    compact_disk:=true;
2:
    release(z)
  END { compact_disk } ;

(*************************************)
(* THIS PROCEDURE LOADS THE CONTENTS *)
(*   OF A GRAPHICS PAGE FROM DISK    *)
(*************************************)
PROCEDURE LOADGRAF (FILENAME : STRING; offset:integer);

VAR IO : INTEGER;
    F  :   FILE;
                                             (******************************)
      HIRES : RECORD CASE BOOLEAN OF         (* A NEAT WAY TO POINT AT THE *)
                TRUE:  (INTPART: INTEGER);   (* STARTING MEMORY ADDRESS OF *)
                FALSE: (PTRPART: ^INTEGER);  (* THE GRAPHICS SCREEN IN USE *)
              END;                           (******************************)
    
BEGIN  (* LOADGRAF *)

  HIRES.INTPART := 8192;    (* POINTS AT STARTING PLACE TO LOAD GRAPH *)
  RESET(F,FILENAME);           (* OPENS FILE THAT CONTAINS GRAPH WE WANT *)
  if ioresult=0 then
    IO:=BLOCKREAD(F,HIRES.PTRPART^,16,offset*16);  (* READ GRAPH FROM DISK *)
  
END;   (* LOADGRAF *)


(*************************************)
(* THIS PROCEDURE SAVES THE CONTENTS *)
(*   OF A GRAPHICS PAGE TO DISK      *)
(*************************************)
PROCEDURE SAVEGRAF (FILENAME : STRING; offset:integer);

VAR IO : INTEGER;
    F  :   FILE;
                                             (******************************)
      HIRES : RECORD CASE BOOLEAN OF         (* A NEAT WAY TO POINT AT THE *)
                TRUE:  (INTPART: INTEGER);   (* STARTING MEMORY ADDRESS OF *)
                FALSE: (PTRPART: ^INTEGER);  (* THE GRAPHICS SCREEN IN USE *)
              END;                           (******************************)
    
BEGIN  (* SAVEGRAF *)

  HIRES.INTPART := 8192;
  REWRITE(F,FILENAME);                  (* OPEN NEW FILE TO STORE GRAPH *)
  IO:=BLOCKWRITE(F,HIRES.PTRPART^,16,offset*16);  (* WRITE GRAPH TO DISK    *)
  CLOSE(F,LOCK);
  
END;   (* SAVEGRAF *)

function peek(address:integer):integer;
type
  pary=packed array[0..0] of char;
var
  i:record case boolean of
    true:(i:integer);
    false:(j:^pary);
  end;
begin
  i.i:=address;
  peek:=ord(i.j^[0]);
end;

procedure poke(address,valu:integer);
type
  p_ary=packed array[0..0] of char;
var
  i:record case boolean of
    true:(i:integer);
    false:(j:^p_ary);
  end;
begin
  i.i:=address;
  i.j^[0]:=chr(valu);
end;

PROCEDURE goleft;
{move cursor left}
var ch:char;
BEGIN
   ch:=syscom^.crtinfo.left;
   unitwrite(2,ch,1,0,52)
END; {goleft}


PROCEDURE goright;
{move cursor right}
var ch:char;
BEGIN
   ch:=syscom^.crtinfo.right;
   unitwrite(2,ch,1,0,52)
END; {goright}


PROCEDURE goup;
{move cursor up}
var ch:char;
BEGIN
   ch:=syscom^.crtinfo.up;
   unitwrite(2,ch,1,0,52)
END; {goup}


PROCEDURE godown;
{move cursor down}
var ch:char;
BEGIN
   ch:=syscom^.crtinfo.down;
   unitwrite(2,ch,1,0,52)
END; {godown}


PROCEDURE gohome;
{move cursor to home position}
var ch:char;
BEGIN
   ch:=syscom^.crtctrl.home;
   unitwrite(2,ch,1,0,52)
END; {gohome}


PROCEDURE beep;
{ring the bell}
var ch:char;
BEGIN
   ch:=chr(7);          { the "BELL" character }
   unitwrite(2,ch,1,0,52)
END; {beep}


PROCEDURE clreoln;
{clear from cursor to end of line}
var ch:char;
BEGIN
   ch:=syscom^.crtctrl.eraseeol;
   unitwrite(2,ch,1,0,52)
END; {clreoln}


PROCEDURE clreosc;
{clear from cursor to end of screen}
var ch:char;
BEGIN
   ch:=syscom^.crtctrl.eraseeos;
   unitwrite(2,ch,1,0,52)
END; {clreosc}


PROCEDURE clrline;
{clear entire line at cursor}
var ch:char;
BEGIN
   ch:=syscom^.crtctrl.clearline;
   unitwrite(2,ch,1,0,52)
END; {clrline}


PROCEDURE clrscrn;
{clear screen}
var ch:char;
BEGIN
   ch:=syscom^.crtctrl.clearscreen;
   unitwrite(2,ch,1,0,52)
END; {clrscrn}

procedure inverse;
  var
    ch:char;
  begin
    ch:=chr(15);
    unitwrite(1,ch,1);
  end;

procedure normal;
  var
    ch:char;
  begin
    ch:=chr(14);
    unitwrite(1,ch,1);
  end;

procedure mtoff; { turn off mousetext characters }
  var
    ch:char;
  begin
    ch:=chr(24);
    unitwrite(1,ch,1);
  end;

procedure mton; { turn on mousetext characters }
  var
    ch:char;
  begin
    ch:=chr(27);
    unitwrite(1,ch,1);
  end;

procedure curoff;  { turn off the cursor }
  var
    ch:char;
  begin
    ch:=chr(6);
    unitwrite(1,ch,1);
  end;

procedure curon; { turn on the cursor }
  var
    ch:char;
  begin
    ch:=chr(5);
    unitwrite(1,ch,1);
  end;

procedure clearline(linenum:integer);
var
  ch:char;
begin
  if ((linenum>=0) and (linenum<=23)) then
    begin
      gotoxy(0,linenum);
      ch:=chr(ord('Z')-ord('@'));
      unitwrite(1,ch,1,0,12);
    end;
end;

procedure display_block(var buffer:bytestream);
  var
    cr,inv:char;
    c,d,x:integer;
    s:packed array[0..7] of char;
    temp:packed array[0..1] of char;
  begin
    temp[1]:=chr(14);
    inv:=chr(15);
    cr:=chr(13);
    s:='        ';
    for c:=1 to 8 do
      begin
        unitwrite(1,s,8);
        for d:=1 to 64 do
          begin
            x:=ord(buffer[(c-1)*64+d]);
            if x>127 then
              begin
                x:=x-128;
                unitwrite(1,inv,1);
              end;
            if x<32 then
              begin
                x:=x+64;
                unitwrite(1,inv,1);
              end;
            temp[0]:=chr(x);
            unitwrite(1,temp,2);
          end;
        unitwrite(1,cr,1);
      end;
    unitwrite(1,cr,1);
  end;


{ generic READLN for strings }
procedure freadln(var ss:string);
var
  i:integer;
  ch:char;
  z:string;
  cc:string[3];
  endline:boolean;
  
begin
  endline:=false;
  fillchar(z,sizeof(z),0);
  cc:='   ';
  cc[1]:=chr(8);
  cc[3]:=chr(8);
  repeat
    unitread(2,ch,1);
    if ch<>chr(8) then
      unitwrite(1,ch,1);
    if ord(ch)=13 then
      endline:=true
    else
      if ord(z[0])=80 then
        unitwrite(1,cc[1],3);
    if ch in ['a'..'z'] then
      ch:=chr(ord(ch)-ord('a')+ord('A'));
    if (ch = chr(128+27) ) or (ch = chr(27)) then       { check for ESC }
      exit(pcode);
    if ord(ch) > 31 then
      begin
        z[0]:=chr(ord(z[0])+1);      { lengthen string }
        if ord(z[0])>80 then
          z[0]:=chr(80);
        z[ord(z[0])]:=ch;               { add character }
      end;
    if ord(ch)=8 then           { shorten string }
      begin
        if ord(z[0])>0 then
          begin
            z[0]:=chr(ord(z[0])-1);
            unitwrite(1,cc[1],3);
          end;
      end;
    if ord(ch)=(ord('X')-ord('@')) then
      begin
        for i:=1 to ord(z[0]) do
          unitwrite(1,cc[1],3);
        z[0]:=chr(0);
      end;
  until endline;
  ss:=z;
end;

procedure bye;
begin
  page(output);
  gotoxy(36,12);
  write('bye bye!');
  exit(pcode);
end;

PROCEDURE fillspace( ch:char; len:integer );
{write ch in len spaces on screen}
var i:integer;
ch1:char;
BEGIN
  ch1:=' ';
  i:=len;
  while i>1 do
    begin
      unitwrite(2,ch1,1,0,52);
      i:=i-1;
    end;
  unitwrite(2,ch,1,0,52);
END; {fillspace}


PROCEDURE center( s:string );
{ center string on line; cursor assumed to be at left of line }
var i:integer;
ch:char;
BEGIN
   ch:=syscom^.crtctrl.clearline;
   unitwrite(2,ch,1,0,52);
   ch:=' ';
   i:=length(s) div 2;
   while i>0 do
     begin
       unitwrite(2,ch,1,0,52);
       i:=i-1;
     end;
   unitwrite(2,s[1],length(s),0,52);
END; { center }

procedure promptat(x,y:integer;s:string);
begin
  gotoxy(x,y);
  unitwrite(1,s[1],ord(s[0]),0,52);
end;

procedure fwrite(ch:char);
begin
  unitwrite(1,ch,1,0,12);
end;

procedure fprint(ch:char);
begin
  unitwrite(6,ch,1,0,12);
end;

procedure fwritereal(var f:text; r:real);
var
  z:real;
  i:integer;

begin
  z:=r;
  while z>10000.0 do
    begin
      i:=i+4;
      z:=z/10000.0;
    end;
  write(f,trunc(z));
  z:=z-trunc(z);
  while i>0 do
    begin
      i:=i-1;
      z:=z*10.0;
      write(f,trunc(z));
      z:=z-trunc(z);
    end;
  write(f,'.');
  while z>0.0 do
    begin
      z:=z*10.0;
      write(f,trunc(z));
      z:=z-trunc(z);
    end;
  write(f,'0');
end;

function spacewait:boolean;
var
  esc,esc1,ch:char;
  s:string[45];
begin
  esc1:=chr(155);
  esc:=chr(27);
  GOTOXY(0,0);
  s:='Press SPACE to continue or ESC to escape --> ';
  unitwrite(1,s,ord(s[0]),0,12);
  unitclear(1);
  read(keyboard,ch);
  spacewait:=(ch in [esc,esc1]);
end;

{ get a character from the keyboard and bring to upper case }
function getcharu:char;
var
  ch:char;

begin
  ch:=chr(0);
  unitread(2,ch,1,0,0);
  if ch in ['a'..'z'] then
    ch:=chr(ord(ch)-ord('a')+ord('A'));
  getcharu:=ch;
end;

{ return true if a key is pressed }
function keypress:boolean;
var
  ch:char;
  keystat:record
    ncharsbufd:integer;
    shift,solidapple,openapple:boolean;
  end;

begin
  ch:=chr(0);
  unitwrite(1,ch,1,0,12);
  unitstatus(1,keystat,1);
  keypress:=keystat.ncharsbufd>0;
end;

{ get a character from the keyboard and bring to upper case }
function getchar:char;
var
  ch:char;

begin
  ch:=chr(0);
  unitread(2,ch,1,0,0);
  getchar:=ch;
end;

procedure getroot(var v:vid);
begin
  v:=global.syvid;
end;

procedure setroot(v:vid);
begin
  global.syvid:=v;
end;

{ get the prefix }
procedure getpfx(var volid:vid);
begin
  volid:=global.dkvid;
end;

procedure setpfx(volid:vid);
begin
  global.dkvid:=volid;
end;

procedure getdate(var d:daterec);
begin
  d:=global.thedate;
end;

procedure setdate(d:daterec);
begin
  global.thedate:=d;
end;


