FUNCTION FETCHDIR(FUNIT: INTEGER):boolean;
  VAR LINX: DIRRANGE; OK: BOOLEAN; HNOW: INTEGER;
begin
  with global,syscom^ do
BEGIN FETCHDIR := FALSE;
  WITH UNITABLE[FUNIT] DO
    BEGIN (*READ IN AND VALIDATE DIR*)
      IF GDIRP = NIL THEN NEW(GDIRP);
      UNITREAD(FUNIT,GDIRP^,SIZEOF(DIRECTORY),DIRBLK);
      OK := IORSLT = INOERROR;
      IF OK THEN
	WITH GDIRP^[0] DO
	  BEGIN
            OK := FALSE;
            IF (DFIRSTBLK = 0) AND
               ((DFKIND = UNTYPEDFILE)or(dfkind=securedir)) THEN
	      IF (LENGTH(DVID) > 0) AND (LENGTH(DVID) <= VIDLENG) AND
		 (DNUMFILES >= 0) AND (DNUMFILES <= MAXDIR) THEN
		BEGIN
                  OK := TRUE; (*SO FAR SO GOOD*)
		  IF DVID <> UVID THEN
		    BEGIN (*NEW VOLUME IN UNIT...CAREFUL*)
		      LINX := 1;
		      WHILE LINX <= DNUMFILES DO
			WITH GDIRP^[LINX] DO
			  IF (DFKIND <= UNTYPEDFILE) OR
			     (DFKIND > securedir) OR
			     (LENGTH(DTID) <= 0) OR
			     (LENGTH(DTID) > TIDLENG) OR
			     (DLASTBLK < DFIRSTBLK) OR
			     (DLASTBYTE > FBLKSIZE) OR
			     (DLASTBYTE <= 0) OR
			     (DACCESS.YEAR >= 100) THEN
			    BEGIN OK := FALSE; END
			  ELSE
			    LINX := LINX+1;
		    END
		END;
	    IF OK THEN
	      BEGIN UVID := DVID; UEOVBLK := DEOVBLK;
		TIME(HNOW,DLOADTIME)
	      END
	  END;
      FETCHDIR := OK;
      IF NOT OK THEN
	BEGIN UVID := ''; UEOVBLK := 0;
	  RELEASE(GDIRP); GDIRP := NIL
	END
    END
end;
END (*FETCHDIR*) ;

FUNCTION DIRSEARCH(VAR FTID: TID; FINDPERM: BOOLEAN; FDIR: directory):integer;
  VAR I: DIRRANGE; FOUND: BOOLEAN;
BEGIN
  DIRSEARCH := 0;
  FOUND := FALSE;
  I := 1;
  WHILE (I <= FDIR[0].DNUMFILES) AND NOT FOUND DO
    BEGIN
      WITH FDIR[I] DO
	IF DTID = FTID THEN
	  IF FINDPERM = (DACCESS.YEAR <> 100) THEN
	    BEGIN DIRSEARCH := I; FOUND := TRUE END;
      I := I+1
    END
END (*DIRSEARCH*) ;

PROCEDURE DELENTRY(FINX: DIRRANGE; FDIR: directory);
  VAR I: DIRRANGE;
      x:direntry;
BEGIN
  fillchar(x,sizeof(x),0);
  WITH FDIR[0] DO
    BEGIN
      FOR I := FINX TO DNUMFILES-1 DO FDIR[I] := FDIR[I+1];
      fdir[dnumfiles]:=x; {zeroize the entry }
      DNUMFILES := DNUMFILES-1
    END
END (*DELENTRY*) ;

PROCEDURE INSENTRY(VAR FENTRY: DIRENTRY; FINX: DIRRANGE; FDIR: directory);
  VAR I: DIRRANGE;
BEGIN
  WITH FDIR[0] DO
    BEGIN
      FOR I := DNUMFILES DOWNTO FINX DO FDIR[I+1] := FDIR[I];
      FDIR[FINX] := FENTRY;
      DNUMFILES := DNUMFILES+1
    END
END (*INSENTRY*) ;

procedure writedir(funit: unitnum; fdir: directory);
var
    ok: boolean;
   lde: direntry;
begin
  ok:=false;
  with global do
    begin
      with unitable[funit],fdir[0] do
        begin
          ok := (uvid = dvid);
          IF OK THEN
            BEGIN
              UNITREAD(FUNIT,LDE,SIZEOF(DIRENTRY),DIRBLK);
              IF IORESULT = ORD(INOERROR) THEN
                OK := DVID = LDE.DVID;
            END
          else
            BEGIN SYSCOM^.IORSLT := ILOSTUNIT;
              UVID := ''; UEOVBLK := 0
            END
        END
    end;
  if ok then
    unitwrite(funit,fdir,sizeof(fdir),dirblk);
END (*WRITEDIR*) ;


FUNCTION VOLSEARCH(VAR FVID: VID; LOOKHARD: BOOLEAN; VAR FDIR: directory):intege
  VAR
    LUNIT: UNITNUM;
    OK: BOOLEAN;
    HNOW,LNOW: INTEGER;
BEGIN
  VOLSEARCH := 0;
  OK := FALSE;
  LUNIT := MAXUNIT;
  IF LENGTH(FVID) > 0 THEN
    REPEAT (*FIRST PASS THRU TABLE*)
      OK := FVID = global.UNITABLE[LUNIT].UVID;
      IF NOT OK THEN
        LUNIT := LUNIT-1
    UNTIL OK OR (LUNIT = 0);
  IF NOT OK AND LOOKHARD THEN
    BEGIN
      LUNIT := MAXUNIT; (*CHECK EACH DISK UNIT*)
      REPEAT
	WITH global.UNITABLE[LUNIT] DO
	  IF UISBLKD THEN
            begin
              unitread(lunit,fdir,sizeof(directory),dirblk);
              if ioresult=0 then
                IF (fdir[0].DFIRSTBLK = 0) AND
                   ((fdir[0].DFKIND = UNTYPEDFILE)or
                   (fdir[0].dfkind=securedir)) THEN
                  IF (LENGTH(fdir[0].DVID) > 0) AND
                     (LENGTH(fdir[0].DVID) <= VIDLENG) AND
                     (fdir[0].DNUMFILES >= 0) AND
                     (fdir[0].DNUMFILES <= MAXDIR) THEN
                    begin
                      uvid:=fdir[0].dvid;
                      ok:=(fvid=uvid);
                    end;
            end
          else
            ok:=(fvid=uvid);
	IF NOT OK THEN LUNIT := LUNIT-1
      UNTIL OK OR (LUNIT = 0)
    END;
  IF OK THEN
    BEGIN
      VOLSEARCH := LUNIT;
      IF not(global.UNITABLE[LUNIT].UISBLKD) THEN
	fillchar(fdir,sizeof(fdir),0);
    END
  else
    fillchar(fdir,sizeof(fdir),0);
END (*VOLSEARCH*) ;

procedure eatspaces(var ss:string);
var
  c:integer;
begin
  while ((ss[1]=' ') and (ord(ss[0])>1)) do
    begin
      for c:=2 to ord(ss[0]) do
        ss[c-1]:=ss[c];
      ss[0]:=chr(ord(ss[0])-1);
    end;
end;

procedure parse(var data:bytestream; var offset:integer; var name:string;
                namesize:integer; var chset:charset; doconvert:boolean);
var
  i,j:integer;
  s:string;
  ch:char;
begin
  s:='';
  j:=0;
  i:=offset;
  ch:=data[i];
  if doconvert then
    begin
      if ord(ch)>127 then
        ch:=chr(ord(ch)-128);
      if ch in ['a'..'z'] then
        ch:=chr(ord(ch)-ord('a')+ord('A'));
    end;
  while ch in chset do
    begin
      if j<namesize then
        begin
          j:=j+1;
          s[j]:=ch;
        end;
      i:=i+1;
      ch:=data[i];
      if doconvert then
        begin
          if ord(ch)>127 then
            ch:=chr(ord(ch)-128);
          if ch in ['a'..'z'] then
            ch:=chr(ord(ch)-ord('a')+ord('A'));
        end;
    end;
  s[0]:=chr(j);
  offset:=i;
  name:=s;
end;

FUNCTION  DATESET(VAR GS:STRING;  VAR THEDATE:DATEREC):INTEGER;
  LABEL 1,2,3,5;
  VAR MONINDX,DAYNUM,YEARNUM,I: INTEGER;
      DONE,OK: BOOLEAN; CH: CHAR;
      DELIMS: SET OF ' '..'/';
      MONTHS:PACKED ARRAY[0..15] of string[3];


BEGIN (*DATESET*)
  with thedate do
    begin
      yearnum:=year; monindx:=month; daynum:=day;
    end;
  DELIMS := [' ','-','/'];
  months[0]:='XXX'; { give space for input date }
  months[1]:='JAN'; months[2]:='FEB'; months[3]:='MAR';
  months[4]:='APR'; months[5]:='MAY'; months[6]:='JUN';
  months[7]:='JUL'; months[8]:='AUG'; months[9]:='SEP';
  months[10]:='OCT'; months[11]:='NOV'; months[12]:='DEC';
  months[13]:='BAD'; months[14]:='BAD'; months[15]:='BAD';
  IF LENGTH(GS)>0 THEN
    REPEAT
      DONE := GS[1] <> ' ';
      IF NOT DONE THEN DELETE(GS,1,1)
    UNTIL DONE OR (LENGTH(GS) = 0);
  IF LENGTH(GS)=0 THEN
    GOTO 1;
  if gs[1] in delims then
    begin
      delete(gs,1,1);
      goto 2;
    end;
  DAYNUM := 0;
  REPEAT
    OK := GS[1] IN ['0'..'9'];
    IF OK THEN
      BEGIN
        DAYNUM := (DAYNUM*10+ORD(GS[1])-ORD('0')) MOD 100;
        OK := DAYNUM <= 9; DELETE(GS,1,1)
      END
  UNTIL (LENGTH(GS) = 0) OR NOT OK;
  IF (DAYNUM < 1) OR (DAYNUM > 31) THEN GOTO 1;
  IF LENGTH(GS) > 0 THEN
    REPEAT
      DONE := GS[1] <> ' ';
      IF NOT DONE THEN DELETE(GS,1,1)
    UNTIL DONE OR (LENGTH(GS) = 0);
  IF LENGTH(GS)=0 THEN GOTO 5;
  if not(gs[1] in delims) then
    goto 1;
  delete(gs,1,1);
2:  IF LENGTH(GS) > 0 THEN
    REPEAT
      DONE := GS[1] <> ' ';
      IF NOT DONE THEN DELETE(GS,1,1)
    UNTIL DONE OR (LENGTH(GS) = 0);
  IF (LENGTH(GS)=0) OR (LENGTH(GS) < 3) THEN GOTO 1;
  if gs[1] in delims then
    begin
      delete(gs,1,1);
      goto 3;
    end;
  MONINDX := 12;
  FOR I := 1 TO 3 DO
    BEGIN
      CH := GS[I];
      IF CH >= 'a' THEN
        CH := CHR(ORD(CH)-ORD('a')+ORD('A'));
      MONTHS[0,I] := CH
    END;
  WHILE MONTHS[MONINDX] <> MONTHS[0] DO
    begin
      MONINDX := MONINDX-1;
      IF MONINDX = 0 THEN GOTO 1;
    end;
  DELETE(GS,1,3);
  IF LENGTH(GS) > 0 THEN
    REPEAT
      DONE := GS[1] <> ' ';
      IF NOT DONE THEN DELETE(GS,1,1)
    UNTIL DONE OR (LENGTH(GS) = 0);
  IF LENGTH(GS)=0 THEN GOTO 5;
  IF NOT (GS[1] IN DELIMS) THEN GOTO 1;
  DELETE(GS,1,1);
3:  IF LENGTH(GS) > 0 THEN
    REPEAT
      DONE := GS[1] <> ' ';
      IF NOT DONE THEN DELETE(GS,1,1)
    UNTIL DONE OR (LENGTH(GS) = 0);
  IF LENGTH(GS)=0 THEN GOTO 1;
  YEARNUM := 0;
  REPEAT
    OK := GS[1] IN ['0'..'9'];
    IF OK THEN
      BEGIN
        YEARNUM := YEARNUM*10+ORD(GS[1])-ORD('0');
        OK := YEARNUM <= 999; DELETE(GS,1,1)
      END
  UNTIL (LENGTH(GS) = 0) OR NOT OK;
  IF LENGTH(GS) > 0 THEN GOTO 1;
5:  WITH THEDATE DO
    BEGIN
      YEAR := YEARNUM MOD 100; MONTH := MONINDX; DAY := DAYNUM;
    END;
  DATESET:=1;
  IF FALSE THEN
1:    DATESET:=0;
END (* DATESET *) ;


procedure dialt(c:char; fast,dosound:boolean);
type
  pab = packed array[0..0] of 0..255;
var
  timer:real;
  count:integer;
  num:integer;
  trick:record case boolean of
    true:(i:integer);
    false:(p:^pab);
  end;
begin
  timer:=1.0;                   { 1.022 mhz speed }
  if false then
    timer:=2.5;                 { 2.5 mhz speed }
  if ord(c)>127 then            { strip high bit }
    c:=chr(ord(c)-128);
  if (c>='a') and (c<='z') then { upper case only }
    c:=chr(ord(c)-32);
  case c of
    '0':num:=10;
    '1':num:=1;
    '2':num:=2;
    '3':num:=3;
    '4':num:=4;
    '5':num:=5;
    '6':num:=6;
    '7':num:=7;
    '8':num:=8;
    '9':num:=9;
    'A':num:=13;
    'B':num:=14;
    'C':num:=15;
    'D':num:=0;
    '#':num:=12;
    '*':num:=11;
    ',':num:=-(1);
  otherwise
    num:=-(2);
  end;
  if num<0 then
    begin
      if num=-(1) then
        num:=150
      else
        num:=1500;
      num:=trunc(num*timer);
      for count:=1 to num do;           { waste some time }
    end
  else
    begin                       { main dialing loop }
      trick.i:=-16321;
      trick.p^[0]:=(ord(dosound) mod 2)*32+16+num;
      num:=trunc(timer*50);
      for count:=1 to num do;   { leave tone on until C.O. recognises it }
      trick.p^[0]:=(ord(dosound) mod 2)*32;
      for count:=1 to num do;   { leave off for a while also }
    end;
end;
    
procedure dialp(c:char; fast:boolean);
type
  pab = packed array[0..0] of 0..255;
var
  timer:real;
  count:integer;
  num:integer;
  i:integer;
  num1:integer;
  trick:record case boolean of
    true:(i:integer);
    false:(p:^pab);
  end;
begin
  timer:=1.0;                   { 1.022 mhz speed }
  if false then
    timer:=2.5;                 { 2.5 mhz speed }
  if ord(c)>127 then            { strip high bit }
    c:=chr(ord(c)-128);
  if (c>='a') and (c<='z') then { upper case only }
    c:=chr(ord(c)-32);
  case c of
    '0':num:=10;
    '1':num:=1;
    '2':num:=2;
    '3':num:=3;
    '4':num:=4;
    '5':num:=5;
    '6':num:=6;
    '7':num:=7;
    '8':num:=8;
    '9':num:=9;
    'A':num:=13;
    'B':num:=14;
    'C':num:=15;
    'D':num:=0;
    '#':num:=12;
    '*':num:=11;
    ',':num:=-(1);
  otherwise
    num:=-(2);
  end;
  if num<0 then
    begin
      if num=-(1) then
        num:=150
      else
        num:=1500;
      num:=trunc(num*timer);
      for count:=1 to num do;           { waste some time }
    end
  else
    begin                       { main dialing loop }
      trick.i:=-16220;
      num1:=trunc(timer*55);     { set timer loop }
      for i:=1 to num do
        begin
          trick.p^[0]:=8;                { on hook }
          for count:=1 to num1 do;       { delay some time }
          trick.p^[0]:=141;             { off hook }
          for count:=1 to num1 do;
        end;
    end;
end;
    
procedure onhook;
type
  pab = packed array[0..0] of 0..255;
var
  trick:record case boolean of
    true:(i:integer);
    false:(p:^pab);
  end;
begin
  trick.i:=-16220;
  trick.p^[0]:=8;
end;

procedure offhook;
type
  pab = packed array[0..0] of 0..255;
var
  trick:record case boolean of
    true:(i:integer);
    false:(p:^pab);
  end;
begin
  trick.i:=-16220;
  trick.p^[0]:=141;
end;


